source: rtems/c/src/lib/libbsp/powerpc/psim/tools/runtest @ 0bac405

4.104.114.95
Last change on this file since 0bac405 was 0bac405, checked in by Joel Sherrill <joel.sherrill@…>, on 03/11/08 at 20:17:13

2008-03-11 Joel Sherrill <joel.sherrill@…>

  • runtest: Skip all fatal error tests.
  • Property mode set to 100755
File size: 6.5 KB
Line 
1#!/bin/sh -p
2#
3# Run rtems tests on the powerpc simulator
4# This program generates a simulator script to run each test
5# Typically the test is then run, although it can be generated
6# and left as a file using -s
7#
8#  COPYRIGHT (c) 1989-1999.
9#  On-Line Applications Research Corporation (OAR).
10#
11#  The license and distribution terms for this file may be
12#  found in found in the file LICENSE in this distribution or at
13#  http://www.rtems.com/license/LICENSE.
14#
15#  $Id$
16#
17
18# progname=`basename $0`
19progname=${0##*/}        # fast basename hack for ksh, bash
20
21USAGE=\
22"usage: $progname [ -opts ] test [ test ... ]
23        -o options  -- specify options to be passed to simulator
24        -v          -- verbose
25        -d          -- generate device tree file (as 'test'.device) and exit
26        -l logdir   -- specify log directory (default is 'logdir')
27
28  Specify test as 'test' or 'test.exe'.
29  All multiprocessing tests *must* be specified simply as 'mp01', etc.
30"
31
32# export everything
33set -a
34
35#   log an error to stderr
36prerr()
37{
38    echo "$*" >&2
39}
40
41fatal() {
42    [ "$1" ] && prerr $*
43    prerr "$USAGE"
44    exit 1
45}
46
47warn() {
48    [ "$1" ] && prerr $*
49}
50
51# print args, 1 per line
52ml_echo()
53{
54    for l
55    do
56       echo "$l"
57    done
58}
59
60# run at normal and signalled exit
61test_exit()
62{
63    exit_code=$1
64
65    rm -f ${logfile}.tmp*
66    [ "$sim_pid" ] && kill -9 $sim_pid
67
68    exit $exit_code
69}
70
71#
72# process the options
73#
74# defaults for getopt vars
75#
76# max_run_time is defaulted to 5 minutes
77#
78
79verbose=""
80extra_options=""
81device_and_exit=""
82stdio_setup="yes"
83run_to_completion="yes"
84logdir=log
85update_on_tick="no"
86max_run_time=$((5 * 60))
87using_print_buffer="yes"
88#simulator=/usr1/rtems/work/ada/4.00/ppc_src/b-gdb/sim/ppc/run
89simulator=powerpc-rtems4.9-run
90instruction_limit=1000000000
91sizeof_ram=8388608
92
93while getopts vdl:o:s: OPT
94do
95    case "$OPT" in
96        v)
97            verbose="yes";;
98        d)
99            device_and_exit="yes"
100            run_to_completion="no"
101            stdio_setup="no";;
102        l)
103            logdir="$OPTARG";;
104        o)
105            extra_options="$OPTARG";;
106        r)
107            sizeof_ram="$OPTARG";;
108        s)
109            simulator="$OPTARG";;
110        *)
111            fatal;;
112    esac
113done
114
115let $((shiftcount = $OPTIND - 1))
116shift $shiftcount
117
118args=$*
119
120#
121#  Check some parameters
122#
123
124# JRS CHANGE
125# if [ ! -x ${simulator} ] ; then
126#    fatal "${simulator} is not executable"
127# fi;
128
129#
130# Run the tests
131#
132
133tests="$args"
134if [ ! "$tests" ]
135then
136     set -- `echo *.exe`
137     tests="$*"
138fi
139
140[ -d $logdir ] ||
141  mkdir $logdir || fatal "could not create log directory ($logdir)"
142
143# where the tmp files go
144trap "test_exit" 1 2 3 13 14 15
145
146for tfile in $tests
147do
148
149   tname=`basename $tfile .exe`
150   cpus="1"
151   TEST_TYPE="single"
152
153   case $tname in
154       # size is no longer interactive.
155       capture* | monitor* | termios* | fileio* | pppd*)
156            if [ $run_to_completion = "yes" ]
157            then
158                 warn "Skipping $tname; it is interactive"
159                 continue
160            fi
161            ;;
162       *-node2*)
163           warn "Skipping $tname; 'runtest' runs both nodes when for *-node1"
164           continue;;
165       *-node1*)
166           warn "Running both nodes associated with $tname"
167           variant=`echo $tname | sed 's/.*-node[12]//' | sed 's/\.exe//'`
168           tname=`echo $tname | sed 's/-node.*//'`
169           TEST_TYPE="mp"
170           ;;
171       minimum*|stackchk*|*fatal*|termio*)
172           continue           ;;
173   esac
174
175   if [ $TEST_TYPE = "mp" ]
176   then
177       cpus="1 2"
178
179       logfile1=$logdir/${tname}_1${variant}
180       logfile2=$logdir/${tname}_2${variant}
181       infofile1=$logfile1.info
182       infofile2=$logfile2.info
183
184       rm -f ${logfile1} ${logfile2}
185
186       date=`date`
187       echo "Starting $tname at $date"
188
189       ${simulator} $extra_options -c ${instruction_limit} \
190           -o "/#address-cells 2" \
191           -o "/openprom/options/oea-memory-size ${sizeof_ram}" \
192           -o "/openprom/init/register/pvr 0xfffe0000" \
193           -o "/shm@0xc0000000/reg 0xc0000000 0x10000" \
194           -o "/shm@0xc0000000/key 0x1234" \
195           -o "/sem@0xc0010000/reg 0xc0010000 12" \
196           -o "/sem@0xc0010000/key 0x1234" \
197           -o "/sem@0xc0010000/value 1" ${tname}-node1${variant}.exe | \
198         sed -e 's/ //' -e '/^$/d' > ${logfile1} &
199
200       ${simulator} $extra_options -c ${instruction_limit} \
201           -o "/#address-cells 2" \
202           -o "/openprom/options/oea-memory-size ${sizeof_ram}" \
203           -o "/openprom/init/register/pvr 0xfffe0000" \
204           -o "/shm@0xc0000000/reg 0xc0000000 0x10000" \
205           -o "/shm@0xc0000000/key 0x1234" \
206           -o "/sem@0xc0010000/reg 0xc0010000 12" \
207           -o "/sem@0xc0010000/key 0x1234" \
208           -o "/sem@0xc0010000/value -1" ${tname}-node2${variant}.exe | \
209         sed -e 's/ //' -e '/^$/d' > ${logfile2} &
210
211       wait
212
213   fi
214
215   if [ $TEST_TYPE = "single" ]
216   then
217     logfile=$logdir/${tname}_1
218     infofile=$logfile.info
219
220     rm -f ${logfile}.tmp*
221
222     date=`date`
223     echo "Starting $tname at $date"
224
225     # Generate a device file to get the work done.
226     # The device file must do the following:
227     #
228     #       arrange for more memory (2 Mb)
229
230     if [ "$device_and_exit" = "yes" ]
231     then
232          fatal "Cannot currently generate device files"
233     fi
234
235     # Spin off the simulator in the background
236     #   -c sets an instruction limit
237
238     # Don't need to make sure it won't run forever... since there is
239     # an instruction count limit
240
241     #powerpc-rtems-run $extra_options -c ${instruction_limit} \
242     #     -f ${devicefile} $tfile | sed -e 's/ //' -e '/^$/d' > ${logfile}
243
244     ${simulator} $extra_options -c ${instruction_limit} \
245           -o "/#address-cells 2" \
246           -o "/openprom/options/oea-memory-size ${sizeof_ram}" \
247           -o "/openprom/init/register/pvr 0xfffe0000" \
248           $tfile | sed -e 's/ //' -e '/^$/d' > ${logfile}
249   fi
250
251   # Create the info files
252   for cpu in $cpus
253   do
254   {
255       echo "$date"
256       echo "Test run on: `uname -n`"
257       echo "Host Information:"
258       echo `uname -a`
259       echo
260
261       #sed -e 's/ //' < ${logdir}/${tname}_${cpu}
262       cat ${logdir}/${tname}_${cpu}
263
264       if [ "$ran_too_long" = "yes" ]
265       then
266           echo "Test did NOT finish normally; killed after $max_run_time seconds"
267       fi
268
269       echo
270       date;
271   } > ${logdir}/${tname}_${cpu}.info
272   done
273
274   if [ "$cpus" = "1" ]
275   then
276        mv ${infofile} $logdir/${tname}.info
277        mv ${logfile}  $logdir/${tname}
278   fi
279
280done
281
282echo "Tests completed at " `date`
283test_exit 0
284
285# Local Variables: ***
286# mode:ksh ***
287# End: ***
288
Note: See TracBrowser for help on using the repository browser.